<cfcomponent output="false">
	<!--- disable sessions and client variables,
		 you can re-enable if you want to share session for example if you want user dictionaries to be user specific  --->
	<cfset this.name = "foundeoSpellChecker">
	<cfset this.sessionManagement = false>
	<cfset this.clientManagement = false>

	<!--- for CF10+ this will load the JAR file into the class path for us, CF9 and below will use JavaLoader --->
	<cfset this.javaSettings = StructNew()>
	<cfset this.javaSettings.loadPaths = ArrayNew(1)>
	<cfif FileExists(ExpandPath("./lib/foundeo-spell-checker-3.jar"))>
		<cfset ArrayAppend(this.javaSettings.loadPaths, ExpandPath("./lib/foundeo-spell-checker-3.jar"))>
	<cfelseif FileExists(ExpandPath("./lib/foundeo-spell-checker-3-trial.jar"))>
		<cfset ArrayAppend(this.javaSettings.loadPaths, ExpandPath("./lib/foundeo-spell-checker-3-trial.jar"))>
	</cfif>

	<cffunction name="onRequest" output="true">
		<cfargument name="targetPage">
		<cfinclude template="Application.cfm">
		<cfinclude template="#arguments.targetPage#">
	</cffunction>
</cfcomponent>